import CodeMirror from 'codemirror'
import jsYaml from "js-yaml";
window.jsyaml = jsYaml

import 'codemirror/lib/codemirror.css'
import "codemirror/addon/fold/foldgutter.css"

import 'codemirror/mode/yaml/yaml'
import 'codemirror/mode/javascript/javascript'

import 'codemirror/addon/lint/lint'
import 'codemirror/addon/lint/lint.css'
import 'codemirror/addon/lint/json-lint'
import 'codemirror/addon/lint/yaml-lint'

import 'codemirror/theme/rubyblue.css'

import 'codemirror/addon/edit/matchbrackets'
import 'codemirror/addon/selection/active-line'

import 'codemirror/addon/edit/closebrackets'

import "codemirror/addon/fold/foldgutter"
import "codemirror/addon/fold/xml-fold"
import "codemirror/addon/fold/foldcode"
import "codemirror/addon/fold/brace-fold"
import "codemirror/addon/fold/indent-fold.js"
import "codemirror/addon/fold/markdown-fold.js"
import "codemirror/addon/fold/comment-fold.js"


require("script-loader!jsonlint")

const commonConfig = {
    lint: true,
    smartIndent: true,
    styleActiveLine: true,
    lineNumbers: true,
    lineWrapping: true,
    matchBrackets: true,
    autoCloseBrackets: true,
    autoRefresh: true,
    // theme: 'rubyblue',
    gutters: [
        "CodeMirror-linenumbers",
        "CodeMirror-foldgutter",
        "CodeMirror-lint-markers",
    ],
    foldGutter: true,
}


const fart = function (el, binding) {
    const {
        arg,
        value,
        modifiers
    } = binding
    const {readOnly} = modifiers
    const {data, callback} = value || {}

    const map = {'json': 'application/json'}

    const config = Object.assign(
        {},
        commonConfig,
        {mode: map[arg] || arg, readOnly: !!readOnly}
    )

    el.codemirror = CodeMirror.fromTextArea(el, config)

    if (arg === 'yaml') {
        el.codemirror.setValue(data)
    } else if (arg === 'json') {
        el.codemirror.setValue(JSON.stringify(data, null, 2))
    }

    if (callback) {
        el.codemirror.on('change', code => callback(code.getValue()))
    }
}

const ButtDirective = {}
ButtDirective.install = function install(Vue) {
    Vue.directive('butt', {
        deep: true,
        inserted: function bind(el, binding) {
            fart(el, binding)
        },
        componentUpdated: function componentUpdated(el, binding) {
            fart(el, binding)
        }
    })
}

export default ButtDirective
